package com.company.untitled1.entity;

import com.haulmont.cuba.core.entity.BaseStringIdEntity;
import com.haulmont.cuba.core.global.DdlGeneration;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

@DdlGeneration(value = DdlGeneration.DbScriptGenerationMode.CREATE_ONLY)
@Table(name = "dzp_org_main")
@Entity(name = "untitled1_DzpOrgMain")
public class DzpOrgMain extends BaseStringIdEntity {
    private static final long serialVersionUID = 1736101919860039174L;

    @Id
    @Column(name = "id", nullable = false, length = 2147483647)
    private String id;

    @JoinColumn(name = "agreement_kg")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpAgreementKg agreementKg;

    @JoinColumn(name = "agreement_kind")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpAgreementKind agreementKind;

    @JoinColumn(name = "category")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpCategory category;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "dt_confirm")
    private Date dtConfirm;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "dt_consult")
    private Date dtConsult;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "dt_consult_fact")
    private Date dtConsultFact;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "end_date")
    private Date endDate;

    @Column(name = "enlistment_flag")
    private Double enlistmentFlag;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "enroll1_fact_dt")
    private Date enroll1FactDt;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "enroll1_plan_dt")
    private Date enroll1PlanDt;

    @JoinColumn(name = "enroll1_state")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpEnrollState enroll1State;

    @JoinColumn(name = "head_id")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpOrg head;

    @Column(name = "is_constaccompan", length = 50)
    private String isConstaccompan;

    @JoinColumn(name = "lang")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpLang lang;

    @JoinColumn(name = "pass_method")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpPassMethod passMethod;

    @JoinColumn(name = "period")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpPeriod period;

    @JoinColumn(name = "pm_id")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpPm pm;

    @JoinColumn(name = "rfo_id")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpOrg rfo;

    @JoinColumn(name = "rm_id")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpRm rm;

    @JoinColumn(name = "scheme")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpScheme scheme;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "start_date")
    private Date startDate;

    @Column(name = "stuff", precision = 131089, scale = 0)
    private BigDecimal stuff;

    @JoinColumn(name = "upd_kind")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpUpdKind updKind;

    @JoinColumn(name = "work_state")
    @ManyToOne(fetch = FetchType.LAZY)
    private DzpWorkState workState;

    public void setAgreementKg(DzpAgreementKg agreementKg) {
        this.agreementKg = agreementKg;
    }

    public DzpAgreementKg getAgreementKg() {
        return agreementKg;
    }

    public void setAgreementKind(DzpAgreementKind agreementKind) {
        this.agreementKind = agreementKind;
    }

    public DzpAgreementKind getAgreementKind() {
        return agreementKind;
    }

    public void setPassMethod(DzpPassMethod passMethod) {
        this.passMethod = passMethod;
    }

    public DzpPassMethod getPassMethod() {
        return passMethod;
    }

    public void setPeriod(DzpPeriod period) {
        this.period = period;
    }

    public DzpPeriod getPeriod() {
        return period;
    }

    public void setWorkState(DzpWorkState workState) {
        this.workState = workState;
    }

    public DzpWorkState getWorkState() {
        return workState;
    }

    public void setEnroll1State(DzpEnrollState enroll1State) {
        this.enroll1State = enroll1State;
    }

    public DzpEnrollState getEnroll1State() {
        return enroll1State;
    }

    public void setCategory(DzpCategory category) {
        this.category = category;
    }

    public DzpCategory getCategory() {
        return category;
    }

    public void setLang(DzpLang lang) {
        this.lang = lang;
    }

    public DzpLang getLang() {
        return lang;
    }

    public void setUpdKind(DzpUpdKind updKind) {
        this.updKind = updKind;
    }

    public DzpUpdKind getUpdKind() {
        return updKind;
    }

    public void setScheme(DzpScheme scheme) {
        this.scheme = scheme;
    }

    public DzpScheme getScheme() {
        return scheme;
    }

    public void setHead(DzpOrg head) {
        this.head = head;
    }

    public DzpOrg getHead() {
        return head;
    }

    public void setRfo(DzpOrg rfo) {
        this.rfo = rfo;
    }

    public DzpOrg getRfo() {
        return rfo;
    }

    public void setRm(DzpRm rm) {
        this.rm = rm;
    }

    public DzpRm getRm() {
        return rm;
    }

    public void setPm(DzpPm pm) {
        this.pm = pm;
    }

    public DzpPm getPm() {
        return pm;
    }

    public BigDecimal getStuff() {
        return stuff;
    }

    public void setStuff(BigDecimal stuff) {
        this.stuff = stuff;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    public String getIsConstaccompan() {
        return isConstaccompan;
    }

    public void setIsConstaccompan(String isConstaccompan) {
        this.isConstaccompan = isConstaccompan;
    }

    public Date getEnroll1PlanDt() {
        return enroll1PlanDt;
    }

    public void setEnroll1PlanDt(Date enroll1PlanDt) {
        this.enroll1PlanDt = enroll1PlanDt;
    }

    public Date getEnroll1FactDt() {
        return enroll1FactDt;
    }

    public void setEnroll1FactDt(Date enroll1FactDt) {
        this.enroll1FactDt = enroll1FactDt;
    }

    public Double getEnlistmentFlag() {
        return enlistmentFlag;
    }

    public void setEnlistmentFlag(Double enlistmentFlag) {
        this.enlistmentFlag = enlistmentFlag;
    }

    public Date getEndDate() {
        return endDate;
    }

    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

    public Date getDtConsultFact() {
        return dtConsultFact;
    }

    public void setDtConsultFact(Date dtConsultFact) {
        this.dtConsultFact = dtConsultFact;
    }

    public Date getDtConsult() {
        return dtConsult;
    }

    public void setDtConsult(Date dtConsult) {
        this.dtConsult = dtConsult;
    }

    public Date getDtConfirm() {
        return dtConfirm;
    }

    public void setDtConfirm(Date dtConfirm) {
        this.dtConfirm = dtConfirm;
    }

    @Override
    public void setId(String id) {
        this.id = id;
    }

    @Override
    public String getId() {
        return id;
    }
}